<script lang="ts">
  import { isGameFinished } from '../helpers/grid'
  import { switchPlayersTurn, toggleGameOver, updateGrid } from '../store'
  import type { ColumnT, GridT, PlayerT } from '../types'
  import Column from './Column.svelte'

  export let grid: GridT
  export let dice: PlayerT['diceInHand']
  export let playerId: PlayerT['id']
  export let reverse = false

  $: isPlayerTurn = Boolean(dice)

  function onSelectColumn(column: ColumnT) {
    if (!isPlayerTurn) return

    const columnIsCompleted = column.every(b => Boolean(b.dice))

    if (columnIsCompleted) return

    const columnKey = column[0].column
    updateGrid(playerId, dice, columnKey)

    const isGameOver = isGameFinished(grid)

    if (isGameOver) {
      toggleGameOver(true)
      return
    }

    switchPlayersTurn(playerId)
  }

  console.log(`grid ${playerId}`, grid)
</script>

<div class="flex gap-4">
  {#each Object.values(grid) as column}
    <Column {column} {onSelectColumn} {isPlayerTurn} {reverse} />
  {/each}
</div>
